<?php
require 'CountMail.php';
require 'GenerateCode.php';

function SendEmailActForm()
{
  if (!isset($_COOKIE['iduser']) or !isset($_COOKIE['hash'])) //если юзер не авторизован то вместо активации перенапраляем на начальную страницу
  {
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
    else header('Location: http://'.$GLOBALS['HostName']);
    exit();
  }

  $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
  <tr><td><div align="center">{msg}</div></td></tr><tr><td height="10px"></td></tr></table>';

  $hash = $_COOKIE['hash'];
  $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT name, email, emailcode FROM users WHERE user_hash=? LIMIT 1");
  mysqli_stmt_bind_param($stmt, "s", $hash);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $name, $email, $emailcode); //дастаём из базы нужные параметры для отправки письма
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if ($emailcode == 1) {$html = str_replace('{msg}', 'Ваша учётная запись активирована по email.', $html);}
  else{
  // код активации для отправки по Email
  $ALLOWED_CHARS = '0123456789';
  $code = '';
  mt_srand(hrtime()[1]);
  for ($i = 0; $i < 6; $i++) {
  $char = substr($ALLOWED_CHARS, mt_rand(0, strlen($ALLOWED_CHARS) - 1), 1);   
  $code .= $char;}// сохраняем накопительно код 

  // добавляем в базу код активации
  $stmt = mysqli_prepare($GLOBALS['DB'], 'UPDATE users SET emailcode=? WHERE user_hash=?');
  mysqli_stmt_bind_param($stmt, 'ss', $code, $hash);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_close($stmt);

  $np = CountMail($email);//узнаём сколько всего отправлено писем на данный ящик за предыдущий час
  if ($np>9){ //ограничение на 10 писем в час
    $html = str_replace('{msg}', 'Превышен лимит по отправке писем на Ваш почтовый адрес за 1 час.<br>Попробуйте активацию позже через свою учётную запись.', $html);
  }else{
    $n = CountMail(); //узнаём сколько всего отправлено писем за предыдущий час
    if ($n>195){ // реальный лимит 200, но берём с запасом на всякий случай
      $html = str_replace('{msg}', 'Превышен лимит по отправке писем за 1 час.<br>Попробуйте активацию позже через свою учётную запись.', $html);
    }else{
  
      //готовим письмо для активации учётной записи
      $stremail = str_replace('@','<span>@</span>',$email); //чтобы адрес в письме оттображался как plain-text, без ссылки
      $stremail = str_replace('.','<span>.</span>',$email);

      $subject = 'Активация учётной записи на AGI.place';   
      $headers = "From: AGI.place <mail@agi.place>\n";
      $headers .= "Content-type: text/html; charset=\"utf-8\"\n";
      $headers .= "Return-path: <mail@agi.place>\n";
      $message = 'Уважаемый(ая) <b>'.$name.'</b><br><br>'."\n";
      $message .= 'Для активации своей учётной записи введите данный код:<br><br>'."\n";
      $message .= '<b>'.$code.'</b><br><br>'."\n";
      $message .= 'С Уважением<br>'."\n";
      $message .= 'администратор форума AGI.place'."\n";

      if (!mail($email, $subject, $message, $headers)){
        $html = str_replace('{msg}', 'Что-то пошло не так.<br>Попробуйте активацию позже через свою учётную запись.', $html);
      }else{
        $html = file_get_contents('./templates/activateForm.html'); //загружаем шаблон формы активации   
        $html = str_replace('{iduser}', $hash, $html);
        $html = str_replace('{action}', 'TryActivateEmail.php', $html);
        $html = str_replace('{error}', '', $html);
        $text = '<br>Для активации учётной записи введите код, отправленный Вам по электронной почте.<br>'.
        'Либо перейдите по ссылке в полученном письме.';
        $html = str_replace('{text}', $text, $html);
      }

      $sendtime = date('Y-m-d H:i:s'); //добавляем в базу для подсчёта отправленных писем
      $stmt = mysqli_prepare($GLOBALS['DB'], 'INSERT INTO mailcounter SET email=?, sendtime=?');
      mysqli_stmt_bind_param($stmt, 'ss', $email, $sendtime);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_close($stmt);
    }
  }
  }
  return $html;
}
?>