<?php
function ShowPM(){
  if ($GLOBALS['islogged']){ //если юзер залогинен 
    $id = (int)substr($_GET['id'], 0, 7); // id сообщения

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT pm.id_to, pm.id_from, pm.sendtime, pm.topic, pm.message, pm.isdelete_to, 
      users.name, users.avatar, users.showonline, users.timevisit, users.status, users.deleted
      FROM pm LEFT JOIN users ON pm.id_from = users.iduser WHERE pm.id_pm=? LIMIT 1');
    mysqli_stmt_bind_param($stmt, 'i', $id); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $id_to, $id_from, $sendtime, $topic, $message, $isdelete_to, $name, $avatar, $showonline, $timevisit, $status, $deleted);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    if (($id_to == $_COOKIE['iduser']) and ($isdelete_to == 0)){ //проверяем уровень доступа и факт удаления
      $html = file_get_contents('./templates/pmshow.html');

      $html ='<table width="100%" style="background-color: #ffffff; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
      <tr><td><div align="center">Входящее личное сообщение</div></td></tr>
      <tr><td height="4px"></td></tr></table>'.$html; //заголовок страницы

      $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT timezone, timeformat FROM users WHERE iduser=? LIMIT 1"); //достаём настройки отображения контента
      mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $timezone, $timeformat);
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);

      $html = str_replace('{name}',$name, $html);

      if (!empty($avatar)) //если аватар есть - выводим его
      $html = str_replace('{avatar}','<a href="./?ai=50&id={id}"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Перейти на страницу участника"></a>', $html); 
      else $html = str_replace('{avatar}','', $html);

      if (empty($topic)) $topic = '(без темы)';
      $html = str_replace('{topic}',$topic, $html);
      require 'TagFormat.php';
      $html = str_replace('{message}', TagFormat($message), $html); //выводим сообщение со всеми тэгами
      $html = str_replace('{mode}', '0', $html); // 0 - режим удаления входящих сообщений
      $html = str_replace('{status}', $status, $html);
      $reply = "'./?ai=25&id={pm_id}'";
      $reply = '<input type="button" value="Ответить" onClick="location.href='.$reply.'" style="font-size: 15px">';
      $html = str_replace('{reply}', $reply, $html);
      $html = str_replace('{pm_id}', $id, $html);       
      $html = str_replace('{id}',$id_from, $html);

      $date = date_create($sendtime); //для отображения смещаем время на указанное в настройках количество часов
      if ($timezone < 0){
        $timeshift = abs($timezone);
        date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
      }else{
        date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
      }
      $sendtime = date_format($date, $timeformat);
      $html = str_replace('{date}',$sendtime, $html);

      if ($showonline == 1){ //если пользователь разрешил в настройках показ своего онлайн-статуса
        $nowtime = strtotime(date("Y-m-d H:i:s")); //берём текущее время и преобразуем в метку времени Unix
        $lastvisit = strtotime($timevisit);

        $date = date_create($timevisit); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $timevisit = date_format($date, $timeformat);

        if (($nowtime-$lastvisit)>300){ //если пользователь загружал страницы форума 5 минут назад - полагаем, что он оффлайн
          $html = str_replace('{online}','<img src="./pics/offline.png" alt="offline" title="Оффлайн. Визит: '.$timevisit.'"></a>', $html); 
        }else{ // иначе - онлайн
          $html = str_replace('{online}','<img src="./pics/online.png" alt="online" title="Онлайн. Визит: '.$timevisit.'"></a>', $html); 
        }    
      }else{
        $html = str_replace('{online}','<img src="./pics/na.png" alt="NA" title="Онлайн-статус недоступен"></a>', $html); 
      }  

      $stmt = mysqli_prepare($GLOBALS['DB'], 'UPDATE pm SET isread=1 WHERE id_pm=? LIMIT 1'); //помечаем как прочитанное
      mysqli_stmt_bind_param($stmt, 's', $id);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_close($stmt);

      return $html;
      exit();
    }else{ // если сообщение удалено у получателя, отсутствует или чужое - переходим на список писем
      if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=22');
      else header('Location: http://'.$GLOBALS['HostName'].'/?ai=22');  
      exit();
    }
  }else{ //если юзер не залогинен
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">Авторизуйтесь, чтобы просматривать личные сообщения.</div></td></tr><tr><td height="10px"></td></tr></table>';  
    return $html; //не используем сообщения ai=200 чтобы после авторизации вернуться на ту же страницу
  }
}
?>