<?php
function TagFormat($text){ //тэги в тексте заменяем на html-код
  $text = str_replace('&', '&amp;', $text);  //экранирование html-кода
  $text = str_replace('<', '&lt;', $text);
  $text = str_replace('>', '&gt;', $text);
  $text = str_replace('"', '&quot;', $text);
  $text = str_replace('`', '&#x60;', $text);

  $text = preg_replace("/\[b\](.*?)\[\/b\]/si","<b>\\1</b>",$text);
  $text = preg_replace("/\[i\](.*?)\[\/i\]/si","<i>\\1</i>",$text);
  $text = preg_replace("/\[u\](.*?)\[\/u\]/si","<u>\\1</u>",$text);
  $text = preg_replace("/\[sup\](.*?)\[\/sup\]/si","<sup>\\1</sup>",$text);
  $text = preg_replace("/\[sub\](.*?)\[\/sub\]/si","<sub>\\1</sub>",$text);
  $text = preg_replace("/\[del\](.*?)\[\/del\]/si","<del>\\1</del>",$text);
  $text = preg_replace("/\[c=(.*?)\](.*?)\[\/c\]/si","<span style='color:#\\1'>\\2</span>",$text);
  $text = preg_replace("/\[h=(.*?)\](.*?)\[\/h\]/si","<span style='font-size:\\1px'>\\2</span>",$text);
  $text = preg_replace("/\[url=http:\/\/(.*?)\](.*?)\[\/url\]/si","<a href='http://\\1'>\\2</a>",$text); // эти 3 именно в таком порядке
  $text = preg_replace("/\[url=https:\/\/(.*?)\](.*?)\[\/url\]/si","<a href='https://\\1'>\\2</a>",$text);
  $text = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/si","<a href='http://\\1'>\\2</a>",$text);
  $text = preg_replace("/\[y\](.*?)\[\/y\]/si",
  "<iframe width='560' height='315' src='https://www.youtube.com/embed/\\1' frameborder='0' allow='accelerometer;autoplay;clipboard-write;encrypted-media;gyroscope;picture-in-picture' allowfullscreen></iframe>",$text);

  do{ //цикл обработки простых цитат
    $pos1 = stripos($text, '[q]');
    if ($pos1 !== false){
      $text = substr_replace($text, "<div class='Quote'><b>Цитата:</b><br>", $pos1, 3);
      $pos2 = stripos($text, '[/q]', $pos1);
      if ($pos2 !== false){
        $text = substr_replace($text, '</div>', $pos2, 4); 
      }else{ //если автор забыл поставить закрывающийся тэг, ставим за него в конце текста, чтоб не искажать форматирование всей ячейки таблицы
        $text .= '</div>';
      }
    }
  }while($pos1 !== false);

  do{ //цикл обработки сложных цитат
    $pos1 = stripos($text, '[q=');
    if ($pos1 !== false){
      $pos2 = stripos($text, ']', $pos1);
      if ($pos2 !== false){
        $text = substr_replace($text, ':</b><br>', $pos2, 1);
        $text = substr_replace($text, "<div class='Quote'><b>", $pos1, 3);  //<div class='Quote'><b>{name}:</b><br>{text}</div>
        $pos3 = stripos($text, '[/q]', $pos1);
        if ($pos3 !== false){
          $text = substr_replace($text, '</div>', $pos3, 4); 
        }else{ //если автор забыл поставить закрывающийся тэг, ставим за него в конце текста, чтоб не искажать форматирование всей ячейки таблицы
          $text .= '</div>';
        }
      }
    }
  }while(($pos1 !== false) and ($pos2 !== false));

  do{
    $pos1 = stripos($text, '[img]');
    if ($pos1 !== false){
      $pos2 = stripos($text, '[/img]', $pos1);
      if ($pos2 !== false){
        $link = substr($text, $pos1 + 5, $pos2 - $pos1 - 5);
        if (mb_strtolower(substr($link, 0, 4)) != 'http') $link = 'http://'.$link; //добавляем http если ничего нет, иначе откроется локальный адрес
        $html = '<div style="max-width:684px;display:inline-block"><a href="'.$link.'" title="Перейти на оригинал изображения" target="_blank">'.
        '<img style="max-width:100%" src="'.$link.'"/></a></div>';
        $text = substr_replace($text, $html, $pos1, $pos2 - $pos1 + 6);
      }
    }
  }while(($pos1 !== false) and ($pos2 !== false));

  return $text; 
}
?>