<?php
require 'const.php';
session_start();

if (!isset($_POST['id_topic']) or //если что-то отсутствует либо юзер неавторизован, запускаем заглавную страницу
    !isset($_POST['message']) or
    !isset($_COOKIE['iduser']) or
    !isset($_COOKIE['hash']))
{
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
  else header('Location: http://'.$HostName);
  exit();
}

$iduser = intval($_COOKIE['iduser']);
$idmsg = (int)substr(strval($_POST['id_topic']), 0, 7); //получаем в этой переменной id сообщения

$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname);

  $stmt = mysqli_prepare($DB, 'SELECT user_hash FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $user_hash);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if ($user_hash !== $_COOKIE['hash']){ //если хэши не совпадают
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
    else header('Location: http://'.$HostName);
    exit();
  }

  $stmt = mysqli_prepare($DB, 'SELECT id_author FROM posts WHERE id_msg=? LIMIT 1'); //проверяем есть ли сообщение и его автор
  mysqli_stmt_bind_param($stmt, 'i', $idmsg);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $id_author); 
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (!isset($id_author)){
    $_SESSION['msg'] = 'Такого сообщения нет.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
    exit();
  }

  if ($id_author != $iduser){
    $_SESSION['msg'] = 'Нельзя редактировать чужие сообщения.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');  
    exit();
  }

// проверяем все ошибки
  $error = '';
  $message = $_POST['message'];
  $testmsg = trim($message);
  $URLfrom = $_POST['URLfrom'];
  
  if (empty($testmsg)) $error .= '<li>Текст сообщения не может быть пустым</li>'."\n";
  if (strlen($message)>100000) $error .= '<li>Текст сообщения не может превышать 50000 символов</li>'."\n";
 
  // Если есть хотя бы одна ошибка - сохраняем в глобальном массиве введённые поля и снова запускаем форму
  if (!empty($error)){
    $_SESSION['EditMsgForm'] = array();
    $_SESSION['EditMsgForm']['error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    $_SESSION['EditMsgForm']['message'] = $message;
    $_SESSION['EditMsgForm']['URLfrom'] = $URLfrom;

    mysqli_close($DB);
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=11&id='."$idmsg");
    else header('Location: http://'.$HostName.'/?ai=11&id='."$idmsg");
    exit();
  }
 
  // если все поля заполнены правильно - сохраняем исправленное сообщение
  $edittime = date('Y-m-d H:i:s');
  $stmt = mysqli_prepare($DB, 'UPDATE posts SET text=?, edittime=? WHERE id_msg=?');
  mysqli_stmt_bind_param($stmt, 'ssi', $message, $edittime, $idmsg);
  mysqli_stmt_execute($stmt);
  $dber = mysqli_stmt_error($stmt);
  mysqli_stmt_close($stmt);

  mysqli_close($DB);

  if (empty($dber)){ //если обновление в базе произошло без ошибок
    if (strpos($URLfrom,'/?ai=53&') !== false){ //если переход сюда был со страницы со списком сообщений
      if (isset($_SERVER['HTTPS'])) header('Location: '.$URLfrom);//переходим на обновлённое сообщение в списке сообщений
      else header('Location: '.$URLfrom);
    }else{
      if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=9&msg='."$idmsg".'#'."$idmsg");//переходим на обновлённое сообщение в топике
      else header('Location: http://'.$HostName.'/?ai=9&msg='."$idmsg".'#'."$idmsg");
    }
  }else{ //иначе показываем ошибку
    $_SESSION['msg'] = 'Ошибка базы данных: '.$dber;
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
  }
}else{
  $_SESSION['msg'] = 'Ошибка соединения с базой данных: '.mysqli_connect_error();
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
  else header('Location: http://'.$HostName.'/?ai=200');
}
?>